C
C     FFTE: A FAST FOURIER TRANSFORM PACKAGE
C
C     (C) COPYRIGHT SOFTWARE, 2000-2004, 2008-2014, 2020
C         ALL RIGHTS RESERVED
C                BY
C         DAISUKE TAKAHASHI
C         CENTER FOR COMPUTATIONAL SCIENCES
C         UNIVERSITY OF TSUKUBA
C         1-1-1 TENNODAI, TSUKUBA, IBARAKI 305-8577, JAPAN
C         E-MAIL: daisuke@cs.tsukuba.ac.jp
C
C
C     RADIX-2, 3, 4, 5, 6, 8, 9, 10, 12, 15 AND 16 FFT ROUTINE
C
C     FORTRAN77 SOURCE PROGRAM
C
C     WRITTEN BY DAISUKE TAKAHASHI
C
      SUBROUTINE FFT235(A,B,W,N,IP)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*),B(*),W(*)
      DIMENSION IP(*)
C
      KEY=1
      J=1
      L=N
      M=1
      DO 10 K=1,IP(16)
        L=L/16
        IF (L .GE. 2) THEN
          IF (KEY .GE. 0) THEN
            CALL FFT16(A,B,W(J),M,L)
          ELSE
            CALL FFT16(B,A,W(J),M,L)
          END IF
          KEY=-KEY
        ELSE
          IF (KEY .GE. 0) THEN
            CALL FFT16(A,A,W(J),M,L)
          ELSE
            CALL FFT16(B,A,W(J),M,L)
          END IF
        END IF
        M=M*16
        J=J+L*15
   10 CONTINUE
      DO 20 K=1,IP(15)
        L=L/15
        IF (L .GE. 2) THEN
          IF (KEY .GE. 0) THEN
            CALL FFT15(A,B,W(J),M,L)
          ELSE
            CALL FFT15(B,A,W(J),M,L)
          END IF
          KEY=-KEY
        ELSE
          IF (KEY .GE. 0) THEN
            CALL FFT15(A,A,W(J),M,L)
          ELSE
            CALL FFT15(B,A,W(J),M,L)
          END IF
        END IF
        M=M*15
        J=J+L*14
   20 CONTINUE
      DO 30 K=1,IP(12)
        L=L/12
        IF (L .GE. 2) THEN
          IF (KEY .GE. 0) THEN
            CALL FFT12(A,B,W(J),M,L)
          ELSE
            CALL FFT12(B,A,W(J),M,L)
          END IF
          KEY=-KEY
        ELSE
          IF (KEY .GE. 0) THEN
            CALL FFT12(A,A,W(J),M,L)
          ELSE
            CALL FFT12(B,A,W(J),M,L)
          END IF
        END IF
        M=M*12
        J=J+L*11
   30 CONTINUE
      DO 40 K=1,IP(10)
        L=L/10
        IF (L .GE. 2) THEN
          IF (KEY .GE. 0) THEN
            CALL FFT10(A,B,W(J),M,L)
          ELSE
            CALL FFT10(B,A,W(J),M,L)
          END IF
          KEY=-KEY
        ELSE
          IF (KEY .GE. 0) THEN
            CALL FFT10(A,A,W(J),M,L)
          ELSE
            CALL FFT10(B,A,W(J),M,L)
          END IF
        END IF
        M=M*10
        J=J+L*9
   40 CONTINUE
      DO 50 K=1,IP(9)
        L=L/9
        IF (L .GE. 2) THEN
          IF (KEY .GE. 0) THEN
            CALL FFT9(A,B,W(J),M,L)
          ELSE
            CALL FFT9(B,A,W(J),M,L)
          END IF
          KEY=-KEY
        ELSE
          IF (KEY .GE. 0) THEN
            CALL FFT9(A,A,W(J),M,L)
          ELSE
            CALL FFT9(B,A,W(J),M,L)
          END IF
        END IF
        M=M*9
        J=J+L*8
   50 CONTINUE
      DO 60 K=1,IP(8)
        L=L/8
        IF (L .GE. 2) THEN
          IF (KEY .GE. 0) THEN
            CALL FFT8(A,B,W(J),M,L)
          ELSE
            CALL FFT8(B,A,W(J),M,L)
          END IF
          KEY=-KEY
        ELSE
          IF (KEY .GE. 0) THEN
            CALL FFT8(A,A,W(J),M,L)
          ELSE
            CALL FFT8(B,A,W(J),M,L)
          END IF
        END IF
        M=M*8
        J=J+L*7
   60 CONTINUE
      DO 70 K=1,IP(6)
        L=L/6
        IF (L .GE. 2) THEN
          IF (KEY .GE. 0) THEN
            CALL FFT6(A,B,W(J),M,L)
          ELSE
            CALL FFT6(B,A,W(J),M,L)
          END IF
          KEY=-KEY
        ELSE
          IF (KEY .GE. 0) THEN
            CALL FFT6(A,A,W(J),M,L)
          ELSE
            CALL FFT6(B,A,W(J),M,L)
          END IF
        END IF
        M=M*6
        J=J+L*5
   70 CONTINUE
      DO 80 K=1,IP(5)
        L=L/5
        IF (L .GE. 2) THEN
          IF (KEY .GE. 0) THEN
            CALL FFT5(A,B,W(J),M,L)
          ELSE
            CALL FFT5(B,A,W(J),M,L)
          END IF
          KEY=-KEY
        ELSE
          IF (KEY .GE. 0) THEN
            CALL FFT5(A,A,W(J),M,L)
          ELSE
            CALL FFT5(B,A,W(J),M,L)
          END IF
        END IF
        M=M*5
        J=J+L*4
   80 CONTINUE
      DO 90 K=1,IP(4)
        L=L/4
        IF (L .GE. 2) THEN
          IF (KEY .GE. 0) THEN
            CALL FFT4(A,B,W(J),M,L)
          ELSE
            CALL FFT4(B,A,W(J),M,L)
          END IF
          KEY=-KEY
        ELSE
          IF (KEY .GE. 0) THEN
            CALL FFT4(A,A,W(J),M,L)
          ELSE
            CALL FFT4(B,A,W(J),M,L)
          END IF
        END IF
        M=M*4
        J=J+L*3
   90 CONTINUE
      DO 100 K=1,IP(3)
        L=L/3
        IF (L .GE. 2) THEN
          IF (KEY .GE. 0) THEN
            CALL FFT3(A,B,W(J),M,L)
          ELSE
            CALL FFT3(B,A,W(J),M,L)
          END IF
          KEY=-KEY
        ELSE
          IF (KEY .GE. 0) THEN
            CALL FFT3(A,A,W(J),M,L)
          ELSE
            CALL FFT3(B,A,W(J),M,L)
          END IF
        END IF
        M=M*3
        J=J+L*2
  100 CONTINUE
      DO 110 K=1,IP(2)
        L=L/2
        IF (L .GE. 2) THEN
          IF (KEY .GE. 0) THEN
            CALL FFT2(A,B,W(J),M,L)
          ELSE
            CALL FFT2(B,A,W(J),M,L)
          END IF
          KEY=-KEY
        ELSE
          IF (KEY .GE. 0) THEN
            CALL FFT2(A,A,W(J),M,L)
          ELSE
            CALL FFT2(B,A,W(J),M,L)
          END IF
        END IF
        M=M*2
        J=J+L
  110 CONTINUE
      RETURN
      END
      SUBROUTINE FFT2(A,B,W,M,L)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*),B(*),W(*)
C
      IF (M .EQ. 1) THEN
        CALL DFT2A(B,A,W,L)
      ELSE
        CALL DFT2C(B,A,L,M)
        CALL DFT2B(B,A,W,L,M)
      END IF
      RETURN
      END
      SUBROUTINE FFT3(A,B,W,M,L)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*),B(*),W(*)
C
      IF (M .EQ. 1) THEN
        CALL DFT3A(B,A,W,L)
      ELSE
        CALL DFT3C(B,A,L,M)
        CALL DFT3B(B,A,W,L,M)
      END IF
      RETURN
      END
      SUBROUTINE FFT4(A,B,W,M,L)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*),B(*),W(*)
C
      IF (M .EQ. 1) THEN
        CALL DFT4A(B,A,W,L)
      ELSE
        CALL DFT4C(B,A,L,M)
        CALL DFT4B(B,A,W,L,M)
      END IF
      RETURN
      END
      SUBROUTINE FFT5(A,B,W,M,L)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*),B(*),W(*)
C
      IF (M .EQ. 1) THEN
        CALL DFT5A(B,A,W,L)
      ELSE
        CALL DFT5C(B,A,L,M)
        CALL DFT5B(B,A,W,L,M)
      END IF
      RETURN
      END
      SUBROUTINE FFT6(A,B,W,M,L)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*),B(*),W(*)
C
      IF (M .EQ. 1) THEN
        CALL DFT6A(B,A,W,L)
      ELSE
        CALL DFT6C(B,A,L,M)
        CALL DFT6B(B,A,W,L,M)
      END IF
      RETURN
      END
      SUBROUTINE FFT8(A,B,W,M,L)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*),B(*),W(*)
C
      IF (M .EQ. 1) THEN
        CALL DFT8A(B,A,W,L)
      ELSE
        CALL DFT8C(B,A,L,M)
        CALL DFT8B(B,A,W,L,M)
      END IF
      RETURN
      END
      SUBROUTINE FFT9(A,B,W,M,L)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*),B(*),W(*)
C
      IF (M .EQ. 1) THEN
        CALL DFT9A(B,A,W,L)
      ELSE
        CALL DFT9C(B,A,L,M)
        CALL DFT9B(B,A,W,L,M)
      END IF
      RETURN
      END
      SUBROUTINE FFT10(A,B,W,M,L)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*),B(*),W(*)
C
      IF (M .EQ. 1) THEN
        CALL DFT10A(B,A,W,L)
      ELSE
        CALL DFT10C(B,A,L,M)
        CALL DFT10B(B,A,W,L,M)
      END IF
      RETURN
      END
      SUBROUTINE FFT12(A,B,W,M,L)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*),B(*),W(*)
C
      IF (M .EQ. 1) THEN
        CALL DFT12A(B,A,W,L)
      ELSE
        CALL DFT12C(B,A,L,M)
        CALL DFT12B(B,A,W,L,M)
      END IF
      RETURN
      END
      SUBROUTINE FFT15(A,B,W,M,L)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*),B(*),W(*)
C
      IF (M .EQ. 1) THEN
        CALL DFT15A(B,A,W,L)
      ELSE
        CALL DFT15C(B,A,L,M)
        CALL DFT15B(B,A,W,L,M)
      END IF
      RETURN
      END
      SUBROUTINE FFT16(A,B,W,M,L)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*),B(*),W(*)
C
      IF (M .EQ. 1) THEN
        CALL DFT16A(B,A,W,L)
      ELSE
        CALL DFT16C(B,A,L,M)
        CALL DFT16B(B,A,W,L,M)
      END IF
      RETURN
      END
      SUBROUTINE SETTBL(W,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 W(*)
      DIMENSION IP(16)
C
      CALL FACTOR2(N,IP)
C
      J=1
      L=N
      DO 10 K=1,IP(16)
        L=L/16
        CALL SETTBL0(W(J),16,L)
        J=J+L*15
   10 CONTINUE
      DO 20 K=1,IP(15)
        L=L/15
        CALL SETTBL0(W(J),15,L)
        J=J+L*14
   20 CONTINUE
      DO 30 K=1,IP(12)
        L=L/12
        CALL SETTBL0(W(J),12,L)
        J=J+L*11
   30 CONTINUE
      DO 40 K=1,IP(10)
        L=L/10
        CALL SETTBL0(W(J),10,L)
        J=J+L*9
   40 CONTINUE
      DO 50 K=1,IP(9)
        L=L/9
        CALL SETTBL0(W(J),9,L)
        J=J+L*8
   50 CONTINUE
      DO 60 K=1,IP(8)
        L=L/8
        CALL SETTBL0(W(J),8,L)
        J=J+L*7
   60 CONTINUE
      DO 70 K=1,IP(6)
        L=L/6
        CALL SETTBL0(W(J),6,L)
        J=J+L*5
   70 CONTINUE
      DO 80 K=1,IP(5)
        L=L/5
        CALL SETTBL0(W(J),5,L)
        J=J+L*4
   80 CONTINUE
      DO 90 K=1,IP(4)
        L=L/4
        CALL SETTBL0(W(J),4,L)
        J=J+L*3
   90 CONTINUE
      DO 100 K=1,IP(3)
        L=L/3
        CALL SETTBL0(W(J),3,L)
        J=J+L*2
  100 CONTINUE
      DO 110 K=1,IP(2)
        L=L/2
        CALL SETTBL0(W(J),2,L)
        J=J+L
  110 CONTINUE
      RETURN
      END
      SUBROUTINE SETTBL0(W,M,L)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 W(M-1,*)
C
      PI2=8.0D0*DATAN(1.0D0)
      PX=-PI2/(DBLE(M)*DBLE(L))
      DO 20 J=1,L
!DIR$ VECTOR ALIGNED
        DO 10 I=1,M-1
          TEMP=PX*DBLE(I)*DBLE(J-1)
          W(I,J)=DCMPLX(DCOS(TEMP),DSIN(TEMP))
   10   CONTINUE
   20 CONTINUE
      RETURN
      END
      SUBROUTINE SETTBL2(W,NX,NY)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 W(NX,*)
C
      PI2=8.0D0*DATAN(1.0D0)
      PX=-PI2/(DBLE(NX)*DBLE(NY))
!$OMP PARALLEL DO PRIVATE(TEMP)
      DO 20 J=1,NY
!DIR$ VECTOR ALIGNED
        DO 10 I=1,NX
          TEMP=PX*DBLE(I-1)*DBLE(J-1)
          W(I,J)=DCMPLX(DCOS(TEMP),DSIN(TEMP))
   10   CONTINUE
   20 CONTINUE
      RETURN
      END
