/*

     FFTE: A FAST FOURIER TRANSFORM PACKAGE

     (C) COPYRIGHT SOFTWARE, 2000-2004, 2008-2014, ALL RIGHTS RESERVED
                BY
         DAISUKE TAKAHASHI
         FACULTY OF ENGINEERING, INFORMATION AND SYSTEMS
         UNIVERSITY OF TSUKUBA
         1-1-1 TENNODAI, TSUKUBA, IBARAKI 305-8573, JAPAN
         E-MAIL: daisuke@cs.tsukuba.ac.jp


     WRITTEN BY DAISUKE TAKAHASHI

     THIS KERNEL WAS GENERATED BY SPIRAL 8.2.0a03
*/

#include <arm_sve.h>

void dft2c_(float64_t  *Y, float64_t  *X, int  *lp1, int  *mp1) {
    int l1, m1;
    svfloat64x2_t s43, s46, svex2_3, svex2_4;
    svfloat64_t s44, s45, s47, s48;
    svbool_t pg1;
    l1 = *(lp1);
    m1 = *(mp1);
    int k1 = 0;
    pg1 = svwhilelt_b64(k1, m1);
    do {
        s43 = svld2_f64(pg1, (X + ((2)*(k1))));
        s44 = s43.v0;
        s45 = s43.v1;
        s46 = svld2_f64(pg1, (X + ((2)*((k1 + ((l1)*(m1)))))));
        s47 = s46.v0;
        s48 = s46.v1;
        svex2_3.v0 = svadd_f64_x(pg1, s44, s47);
        svex2_3.v1 = svadd_f64_x(pg1, s45, s48);
        svst2_f64(pg1, (Y + ((2)*(k1))), svex2_3);
        svex2_4.v0 = svsub_f64_x(pg1, s44, s47);
        svex2_4.v1 = svsub_f64_x(pg1, s45, s48);
        svst2_f64(pg1, (Y + ((2)*((k1 + m1)))), svex2_4);
        k1 += svcntd();
        pg1 = svwhilelt_b64(k1, m1);
    } while(svptest_any(svptrue_b64(), pg1));
}
